Index: krita/ui/opengl/kis_opengl_canvas2.cpp
===================================================================
--- krita/ui/opengl/kis_opengl_canvas2.cpp	(revision 1163293)
+++ krita/ui/opengl/kis_opengl_canvas2.cpp	(working copy)
@@ -31,6 +31,7 @@
 #include <QPaintEvent>
 #include <QPoint>
 #include <QPainter>
+#include <QTransform>
 
 #include <kxmlguifactory.h>
 
@@ -42,12 +43,14 @@
 #include "kis_types.h"
 #include <ko_favorite_resource_manager.h>
 #include "canvas/kis_canvas2.h"
+#include "kis_coordinates_converter.h"
 #include "kis_image.h"
 #include "opengl/kis_opengl.h"
 #include "opengl/kis_opengl_image_textures.h"
 #include "kis_view2.h"
 #include "kis_canvas_resource_provider.h"
 #include "kis_config.h"
+#include "kis_config_notifier.h"
 #include "kis_debug.h"
 #include "kis_selection_manager.h"
 #include "kis_group_layer.h"
@@ -74,9 +77,9 @@
     bool GLStateSaved;
 };
 
-KisOpenGLCanvas2::KisOpenGLCanvas2(KisCanvas2 * canvas, QWidget * parent, KisOpenGLImageTexturesSP imageTextures)
+KisOpenGLCanvas2::KisOpenGLCanvas2(KisCanvas2 * canvas, KisCoordinatesConverter *coordinatesConverter, QWidget * parent, KisOpenGLImageTexturesSP imageTextures)
         : QGLWidget(QGLFormat(QGL::SampleBuffers), parent, KisOpenGL::sharedContextWidget())
-        , KisCanvasWidgetBase(canvas)
+        , KisCanvasWidgetBase(canvas, coordinatesConverter)
         , m_d(new Private())
 {
     m_d->openGLImageTextures = imageTextures;
@@ -92,6 +95,9 @@
     } else {
         dbgUI << "Created QGLWidget with no sharing";
     }
+
+    connect(KisConfigNotifier::instance(), SIGNAL(configChanged()), SLOT(slotConfigChanged()));
+    slotConfigChanged();
 }
 
 KisOpenGLCanvas2::~KisOpenGLCanvas2()
@@ -103,11 +109,11 @@
 {
 }
 
-void KisOpenGLCanvas2::resizeGL(int w, int h)
+void KisOpenGLCanvas2::resizeGL(int width, int height)
 {
-    glViewport(0, 0, (GLint)w, (GLint)h);
-    adjustOrigin();
-    update();
+    glViewport(0, 0, (GLint)width, (GLint)height);
+    coordinatesConverter()->setCanvasWidgetSize(QSize(width, height));
+    emit needAdjustOrigin();
 }
 
 void KisOpenGLCanvas2::paintEvent(QPaintEvent *)
@@ -118,34 +124,16 @@
 
     drawBorder();
 
+    Q_ASSERT(canvas()->image());
+
     if (canvas()->image()) {
         drawBackground();
-
-        if(canvas()->image()->rootLayer()->childCount()>0) {
-            drawImage();
-        }
-
+        drawImage();
         restoreGLState();
 
-        // XXX: make settable
-        bool drawTools = true;
 
-        gc.save();
-        if (canvas()->isCanvasMirrored()){
-            QTransform m = gc.transform();
-            m.translate( documentOrigin().x(), 0);
-            m.scale(-1,1 );
-            m.translate( -documentSize().width(),0 );
-            m.translate( -documentOrigin().x(), 0);
-            gc.setTransform(m);
-        }
-
-        drawDecorations(gc, drawTools,
-                        documentOffset(),
-                        QRect(QPoint(0, 0), documentSize()),
-                        canvas());
-                        
-        gc.restore();
+        QRect boundingRect = coordinatesConverter()->imageRectInWidgetPixels().toAlignedRect();
+        drawDecorations(gc, boundingRect);
     } else {
         restoreGLState();
     }
@@ -153,6 +141,28 @@
     gc.end();
 }
 
+void KisOpenGLCanvas2::loadQTransform(QTransform transform)
+{
+    GLfloat matrix[16];
+    memset(matrix, 0, sizeof(GLfloat) * 16);
+
+    matrix[0] = transform.m11();
+    matrix[1] = transform.m12();
+
+    matrix[4] = transform.m21();
+    matrix[5] = transform.m22();
+
+    matrix[12] = transform.m31();
+    matrix[13] = transform.m32();
+
+    matrix[3] = transform.m13();
+    matrix[7] = transform.m23();
+
+    matrix[15] = transform.m33();
+
+    glLoadMatrixf(matrix);
+}
+
 void KisOpenGLCanvas2::drawBorder()
 {
     QColor widgetBackgroundColor = borderColor();
@@ -163,9 +173,21 @@
 
 void KisOpenGLCanvas2::drawBackground()
 {
-    const qreal scaleX = zoomScaleX();
-    const qreal scaleY = zoomScaleY();
+    KisCoordinatesConverter *converter = coordinatesConverter();
 
+    QTransform textureTransform;
+    QTransform modelTransform;
+    QRectF textureRect;
+    QRectF modelRect;
+    converter->getOpenGLCheckersInfo(&textureTransform, &modelTransform, &textureRect, &modelRect);
+
+    KisConfig cfg;
+    GLfloat checkSizeScale = KisOpenGLImageTextures::BACKGROUND_TEXTURE_CHECK_SIZE / static_cast<GLfloat>(cfg.checkSize());
+
+    textureTransform *= QTransform::fromScale(checkSizeScale / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE,
+                                               checkSizeScale / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE);
+
+
     glMatrixMode(GL_PROJECTION);
     glLoadIdentity();
     glViewport(0, 0, width(), height());
@@ -173,46 +195,30 @@
 
     glMatrixMode(GL_TEXTURE);
     glLoadIdentity();
+    loadQTransform(textureTransform);
 
-    KisConfig cfg;
-    GLfloat checkSizeScale = KisOpenGLImageTextures::BACKGROUND_TEXTURE_CHECK_SIZE / static_cast<GLfloat>(cfg.checkSize());
-
-    glScalef(checkSizeScale, checkSizeScale, 1.0);
-
-    if (cfg.scrollCheckers()) {
-        glTranslatef(static_cast<GLfloat>(documentOffset().x()) / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE,
-                     static_cast<GLfloat>(documentOffset().y()) / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE,
-                     0.0);
-    }
-
-    glScalef(scaleX, scaleY, 1.0);
-
     glMatrixMode(GL_MODELVIEW);
     glLoadIdentity();
-    glTranslatef(documentOrigin().x(), documentOrigin().y(), 0.0);
-    glScalef(scaleX, scaleY, 1.0);
+    loadQTransform(modelTransform);
 
     glBindTexture(GL_TEXTURE_2D, m_d->openGLImageTextures->backgroundTexture());
     glEnable(GL_TEXTURE_2D);
     glShadeModel(GL_FLAT);
 
     glBegin(GL_QUADS);
-
     glColor3f(1.0, 1.0, 1.0);
-    glTexCoord2f(0.0, 0.0);
-    glVertex2f(0.0, 0.0);
 
-    KisImageWSP image = canvas()->image();
+    glTexCoord2f(textureRect.left(), textureRect.top());
+    glVertex2f(modelRect.left(), modelRect.top());
 
-    glTexCoord2f(image->width() / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE, 0.0);
-    glVertex2f(image->width(), 0.0);
+    glTexCoord2f(textureRect.right(), textureRect.top());
+    glVertex2f(modelRect.right(), modelRect.top());
 
-    glTexCoord2f(image->width() / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE,
-                 image->height() / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE);
-    glVertex2f(image->width(), image->height());
+    glTexCoord2f(textureRect.right(), textureRect.bottom());
+    glVertex2f(modelRect.right(), modelRect.bottom());
 
-    glTexCoord2f(0.0, image->height() / KisOpenGLImageTextures::BACKGROUND_TEXTURE_SIZE);
-    glVertex2f(0.0, image->height());
+    glTexCoord2f(textureRect.left(), textureRect.bottom());
+    glVertex2f(modelRect.left(), modelRect.bottom());
 
     glEnd();
 
@@ -222,24 +228,26 @@
 
 void KisOpenGLCanvas2::drawImage()
 {
-    setPixelToViewTransformation();
+    setupImageToWidgetTransformation();
 
-    const qreal scaleX = zoomScaleX();
-
     glEnable(GL_TEXTURE_2D);
-
     glEnable(GL_BLEND);
     glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 
-    QRectF documentRect = viewConverter()->viewToDocument(QRectF(documentOffset().x(), 
-                                                                    documentOffset().y(), 
-                                                                    width(), 
-                                                                    height()));
+
     KisImageWSP image = canvas()->image();
+    KisCoordinatesConverter *converter = coordinatesConverter();
 
-    QRect wr = image->documentToIntPixel(documentRect);
-    wr &= QRect(0, 0, image->width(), image->height());
+    QRectF widgetRect(0,0, width(), height());
+    QRectF widgetRectInImagePixels = converter->
+        documentToImage(converter->widgetToDocument(widgetRect));
 
+    qreal scaleX, scaleY;
+    converter->imageScale(&scaleX, &scaleY);
+
+    QRect wr = widgetRectInImagePixels.toAlignedRect() & image->bounds();
+
+
     if (image->colorSpace()->hasHighDynamicRange()) {
         if (m_d->openGLImageTextures->usingHDRExposureProgram()) {
             m_d->openGLImageTextures->activateHDRExposureProgram();
@@ -249,11 +257,6 @@
 
     makeCurrent();
 
-    if (canvas()->isCanvasMirrored()){
-        glScalef(-1,1,1);
-        glTranslatef(-image->width(),0,0);
-    }
-    
     for (int x = (wr.left() / m_d->openGLImageTextures->imageTextureTileWidth()) * m_d->openGLImageTextures->imageTextureTileWidth();
         x <= wr.right();
         x += m_d->openGLImageTextures->imageTextureTileWidth()) {
@@ -352,7 +355,6 @@
 void KisOpenGLCanvas2::beginOpenGL(void)
 {
     saveGLState();
-    setupMatrices();
 }
 
 void KisOpenGLCanvas2::endOpenGL(void)
@@ -360,7 +362,7 @@
     restoreGLState();
 }
 
-void KisOpenGLCanvas2::setupMatrices(void)
+void KisOpenGLCanvas2::setupImageToWidgetTransformation()
 {
     glMatrixMode(GL_PROJECTION);
     glLoadIdentity();
@@ -371,44 +373,25 @@
     glLoadIdentity();
 
     glMatrixMode(GL_MODELVIEW);
-    glLoadIdentity();
-    glTranslatef(-documentOffset().x(), -documentOffset().y(), 0.0);
-    glTranslatef(documentOrigin().x(),  documentOrigin().y(), 0.0);
-}
 
-void KisOpenGLCanvas2::applyZoomScalingToModelView(void)
-{
-    KisImageWSP image = canvas()->image();
-    
-    if (!image) return;
-    
-    const qreal scaleX = zoomScaleX();
-    const qreal scaleY = zoomScaleY();
-    
-    glMatrixMode(GL_MODELVIEW);
-    glScalef(scaleX, scaleY, 1.0);
+    QTransform transform = coordinatesConverter()->imageToWidgetTransform();
+    loadQTransform(transform);
 }
 
-void KisOpenGLCanvas2::setPixelToViewTransformation(void)
+void KisOpenGLCanvas2::setupFlakeToWidgetTransformation()
 {
-    setupMatrices();
-    applyZoomScalingToModelView();
-}
+    glMatrixMode(GL_PROJECTION);
+    glLoadIdentity();
+    glViewport(0, 0, width(), height());
+    glOrtho(0, width(), height(), 0, NEAR_VAL, FAR_VAL);
 
-qreal KisOpenGLCanvas2::zoomScaleX() const
-{
-    qreal sx, sy;
-    viewConverter()->zoom(&sx, &sy);
+    glMatrixMode(GL_TEXTURE);
+    glLoadIdentity();
 
-    return sx / canvas()->image()->xRes();
-}
+    glMatrixMode(GL_MODELVIEW);
 
-qreal KisOpenGLCanvas2::zoomScaleY() const
-{
-    qreal sx, sy;
-    viewConverter()->zoom(&sx, &sy);
-
-    return sy / canvas()->image()->yRes();
+    QTransform transform = coordinatesConverter()->flakeToWidgetTransform();
+    loadQTransform(transform);
 }
 
 void KisOpenGLCanvas2::enterEvent(QEvent* e)
@@ -422,6 +405,11 @@
     QWidget::leaveEvent(e);
 }
 
+void KisOpenGLCanvas2::slotConfigChanged()
+{
+    notifyConfigChanged();
+}
+
 void KisOpenGLCanvas2::mouseMoveEvent(QMouseEvent *e)
 {
     processMouseMoveEvent(e);
@@ -477,17 +465,6 @@
     processWheelEvent(e);
 }
 
-void KisOpenGLCanvas2::documentOffsetMoved(const QPoint & pt)
-{
-    KisCanvasWidgetBase::documentOffsetMoved(pt);
-    update();
-}
-
-void KisOpenGLCanvas2::emitDocumentOriginChangedSignal()
-{
-    emit documentOriginChanged(documentOrigin());
-}
-
 bool KisOpenGLCanvas2::callFocusNextPrevChild(bool next)
 {
     return focusNextPrevChild(next);
Index: krita/ui/opengl/kis_opengl_canvas2.h
===================================================================
--- krita/ui/opengl/kis_opengl_canvas2.h	(revision 1163293)
+++ krita/ui/opengl/kis_opengl_canvas2.h	(working copy)
@@ -51,7 +51,7 @@
 
 public:
 
-    KisOpenGLCanvas2(KisCanvas2 * canvas, QWidget * parent, KisOpenGLImageTexturesSP imageTextures);
+    KisOpenGLCanvas2(KisCanvas2 * canvas, KisCoordinatesConverter *coordinatesConverter, QWidget * parent, KisOpenGLImageTexturesSP imageTextures);
 
     virtual ~KisOpenGLCanvas2();
 
@@ -61,22 +61,28 @@
      * that primitives can be rendered using coordinates returned 
      * from pixelToView(). 
      */ 
-    void beginOpenGL(void);
+    void beginOpenGL();
 
     /** 
      * Notify the canvas that rendering using native OpenGL commands
      * has finished. This restores the state so that the canvas can 
      * be painted on using a QPainter. 
      */ 
-    void endOpenGL(void);
+    void endOpenGL();
 
     /**
      * Set the projection and model view matrices so that primitives can be
-     * rendered using image pixel coordinates. This handles zooming and scrolling
-     * of the canvas.
+     * rendered using image pixel coordinates. This handles zooming and
+     * scrolling of the canvas.
      */
-    void setPixelToViewTransformation(void);
+    void setupImageToWidgetTransformation();
 
+    /**
+     * The same as \ref setupImageToWidgetTransformation(), but input
+     * coordinate system is flake
+     */
+    void setupFlakeToWidgetTransformation();
+
 public: // QWidget
 
     /// reimplemented method from superclass
@@ -122,19 +128,16 @@
     /// reimplemented method from superclass
     virtual void inputMethodEvent(QInputMethodEvent *event);
 
+private slots:
+    void slotConfigChanged();
+
 signals:
-    /**
-     * This signal is emitted when the document origin has changed.
-     * The document origin is the point (in pixel) on the virtual
-     * canvas where the documents origin (0,0) or the top left
-     * corner of the page is. Copied from Karbon
-     */
-    void documentOriginChanged(const QPoint &origin);
+    void needAdjustOrigin();
 
 protected:
 
+    void resizeGL(int width, int height);
     void initializeGL();
-    void resizeGL(int w, int h);
 
 public: // KisAbstractCanvasWidget
 
@@ -142,30 +145,21 @@
         return this;
     }
 
-    void documentOffsetMoved(const QPoint & pt);
-
 protected: // KisCanvasWidgetBase
-
-    virtual void emitDocumentOriginChangedSignal();
     virtual bool callFocusNextPrevChild(bool next);
 
 private:
     class Private;
     Private * const m_d;
 
+    void loadQTransform(QTransform transform);
+
     void drawBorder();
     void drawImage();
     void drawBackground();
 
-    void setupMatrices();
-    void applyZoomScalingToModelView();
-
-    qreal zoomScaleX() const;
-    qreal zoomScaleY() const;
-
     void saveGLState();
     void restoreGLState();
-
 };
 
 #endif // HAVE_OPENGL
Index: krita/ui/kis_selection_decoration.h
===================================================================
--- krita/ui/kis_selection_decoration.h	(revision 1163293)
+++ krita/ui/kis_selection_decoration.h	(working copy)
@@ -38,7 +38,7 @@
 
     void setMode(Mode mode);
 protected:
-    virtual void drawDecoration(QPainter& gc, const QPoint & documentOffset, const QRect& area, const KoViewConverter &converter);
+    void drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
 public slots:
     void selectionChanged();
     void selectionTimerEvent();
Index: krita/ui/kis_zoom_manager.cc
===================================================================
--- krita/ui/kis_zoom_manager.cc	(revision 1163293)
+++ krita/ui/kis_zoom_manager.cc	(working copy)
@@ -41,6 +41,7 @@
 
 #include "kis_view2.h"
 #include "canvas/kis_canvas2.h"
+#include "kis_coordinates_converter.h"
 #include "kis_image.h"
 #include "kis_statusbar.h"
 #include "kis_config.h"
@@ -156,11 +157,16 @@
     Q_UNUSED(zoom);
     KisImageWSP image = m_view->image();
 
-    m_view->canvasBase()->preScale();
-    m_view->canvasBase()->adjustOrigin();
+    m_view->canvasBase()->notifyZoomChanged();
     m_view->canvas()->update();
 }
 
+void KisZoomManager::slotScrollAreaSizeChanged()
+{
+    QSize widgetSize = m_view->canvasBase()->coordinatesConverter()->imageRectInWidgetPixels().toAlignedRect().size();
+    m_canvasController->updateDocumentSize(widgetSize, true);
+}
+
 void KisZoomManager::changeAspectMode(bool aspectMode)
 {
     KisImageWSP image = m_view->image();
Index: krita/ui/canvas/kis_perspective_grid_manager.cpp
===================================================================
--- krita/ui/canvas/kis_perspective_grid_manager.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_perspective_grid_manager.cpp	(working copy)
@@ -27,7 +27,7 @@
 #include <ktoggleaction.h>
 #include <kactioncollection.h>
 
-#include <KoViewConverter.h>
+#include <QTransform>
 
 #include "canvas/kis_canvas2.h"
 #include "kis_config.h"
@@ -36,7 +36,9 @@
 #include "canvas/kis_grid_painter_configuration.h"
 #include "kis_view2.h"
 #include "kis_canvas_resource_provider.h"
+#include "kis_coordinates_converter.h"
 
+
 KisPerspectiveGridManager::KisPerspectiveGridManager(KisView2 * parent)
         : KisCanvasDecoration("perspectiveGrid", i18n("Perspective grid"), parent)
         , m_toggleEdition(false)
@@ -104,65 +106,66 @@
     }
 }
 
-#define pixelToView(point) \
-    converter.documentToView(image->pixelToDocument(point))
-
-void KisPerspectiveGridManager::drawDecoration(QPainter& gc, const QPoint& documentOffset, const QRect& area, const KoViewConverter &converter)
+void KisPerspectiveGridManager::drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter)
 {
-    Q_UNUSED(documentOffset);
-    Q_UNUSED(area);
+    Q_UNUSED(updateRect);
 
+    if (m_toggleEdition) return;
+
     KisImageWSP image = m_view->resourceProvider()->currentImage();
+    Q_ASSERT(image);
 
+    KisPerspectiveGrid* pGrid = image->perspectiveGrid();
 
-    if (image && !m_toggleEdition) {
-        KisPerspectiveGrid* pGrid = image->perspectiveGrid();
+    QPen mainPen = KisGridPainterConfiguration::mainPen();
+    QPen subdivisionPen = KisGridPainterConfiguration::subdivisionPen();
 
-        KisConfig cfg;
-        QPen mainPen = KisGridPainterConfiguration::mainPen();
-        QPen subdivisionPen = KisGridPainterConfiguration::subdivisionPen();
 
-        for (QList<KisSubPerspectiveGrid*>::const_iterator it = pGrid->begin(); it != pGrid->end(); ++it) {
-            const KisSubPerspectiveGrid* grid = *it;
-            gc.setPen(subdivisionPen);
-            // 1 -> top-left corner
-            // 2 -> top-right corner
-            // 3 -> bottom-right corner
-            // 4 -> bottom-left corner
-            // d12 line from top-left to top-right
-            // note that the notion of top-left is purely theorical
-            LineEquation d12 = LineEquation::Through(toKisVector2D(*grid->topLeft()), toKisVector2D(*grid->topRight()));
-            QPointF v12 = QPointF(*grid->topLeft() - *grid->topRight());
-            v12.setX(v12.x() / grid->subdivisions()); v12.setY(v12.y() / grid->subdivisions());
-            LineEquation d23 = LineEquation::Through(toKisVector2D(*grid->topRight()), toKisVector2D(*grid->bottomRight()));
-            QPointF v23 = QPointF(*grid->topRight() - *grid->bottomRight());
-            v23.setX(v23.x() / grid->subdivisions()); v23.setY(v23.y() / grid->subdivisions());
-            LineEquation d34 = LineEquation::Through(toKisVector2D(*grid->bottomRight()), toKisVector2D(*grid->bottomLeft()));
-            LineEquation d41 = LineEquation::Through(toKisVector2D(*grid->bottomLeft()), toKisVector2D(*grid->topLeft()));
+    QTransform transform = converter->imageToWidgetTransform();
+    gc.save();
+    gc.setTransform(transform);
 
-            KisVector2D horizVanishingPoint = d12.intersection(d34);
-            KisVector2D vertVanishingPoint = d23.intersection(d41);
+    for (QList<KisSubPerspectiveGrid*>::const_iterator it = pGrid->begin(); it != pGrid->end(); ++it) {
+        const KisSubPerspectiveGrid* grid = *it;
 
-            for (int i = 1; i < grid->subdivisions(); i ++) {
-                KisVector2D pol1 = toKisVector2D(*grid->topRight() + i * v12);
-                LineEquation d1 = LineEquation::Through(pol1, vertVanishingPoint);
-                KisVector2D pol1b =  d1.intersection(d34);
-                gc.drawLine(pixelToView(toQPointF(pol1)), pixelToView(toQPointF(pol1b)));
+        gc.setPen(subdivisionPen);
+        // 1 -> top-left corner
+        // 2 -> top-right corner
+        // 3 -> bottom-right corner
+        // 4 -> bottom-left corner
+        // d12 line from top-left to top-right
+        // note that the notion of top-left is purely theorical
+        LineEquation d12 = LineEquation::Through(toKisVector2D(*grid->topLeft()), toKisVector2D(*grid->topRight()));
+        QPointF v12 = QPointF(*grid->topLeft() - *grid->topRight());
+        v12.setX(v12.x() / grid->subdivisions()); v12.setY(v12.y() / grid->subdivisions());
+        LineEquation d23 = LineEquation::Through(toKisVector2D(*grid->topRight()), toKisVector2D(*grid->bottomRight()));
+        QPointF v23 = QPointF(*grid->topRight() - *grid->bottomRight());
+        v23.setX(v23.x() / grid->subdivisions()); v23.setY(v23.y() / grid->subdivisions());
+        LineEquation d34 = LineEquation::Through(toKisVector2D(*grid->bottomRight()), toKisVector2D(*grid->bottomLeft()));
+        LineEquation d41 = LineEquation::Through(toKisVector2D(*grid->bottomLeft()), toKisVector2D(*grid->topLeft()));
 
-                KisVector2D pol2 = toKisVector2D(*grid->bottomRight() + i * v23);
-                LineEquation d2 = LineEquation::Through(pol2, horizVanishingPoint);
-                KisVector2D pol2b = d2.intersection(d41);
-                gc.drawLine(pixelToView(toQPointF(pol2)), pixelToView(toQPointF(pol2b)));
-            }
-            gc.setPen(mainPen);
-            gc.drawLine(pixelToView(*grid->topLeft()), pixelToView(*grid->topRight()));
-            gc.drawLine(pixelToView(*grid->topRight()), pixelToView(*grid->bottomRight()));
-            gc.drawLine(pixelToView(*grid->bottomRight()), pixelToView(*grid->bottomLeft()));
-            gc.drawLine(pixelToView(*grid->bottomLeft()), pixelToView(*grid->topLeft()));
+        KisVector2D horizVanishingPoint = d12.intersection(d34);
+        KisVector2D vertVanishingPoint = d23.intersection(d41);
 
+        for (int i = 1; i < grid->subdivisions(); i ++) {
+            KisVector2D pol1 = toKisVector2D(*grid->topRight() + i * v12);
+            LineEquation d1 = LineEquation::Through(pol1, vertVanishingPoint);
+            KisVector2D pol1b =  d1.intersection(d34);
+            gc.drawLine(toQPointF(pol1), toQPointF(pol1b));
+
+            KisVector2D pol2 = toKisVector2D(*grid->bottomRight() + i * v23);
+            LineEquation d2 = LineEquation::Through(pol2, horizVanishingPoint);
+            KisVector2D pol2b = d2.intersection(d41);
+            gc.drawLine(toQPointF(pol2), toQPointF(pol2b));
         }
+
+        gc.setPen(mainPen);
+        gc.drawLine(*grid->topLeft(), *grid->topRight());
+        gc.drawLine(*grid->topRight(), *grid->bottomRight());
+        gc.drawLine(*grid->bottomRight(), *grid->bottomLeft());
+        gc.drawLine(*grid->bottomLeft(), *grid->topLeft());
     }
+    gc.restore();
 }
 
-
 #include "kis_perspective_grid_manager.moc"
Index: krita/ui/canvas/kis_update_info.cpp
===================================================================
--- krita/ui/canvas/kis_update_info.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_update_info.cpp	(working copy)
@@ -34,7 +34,7 @@
 
 QRect KisOpenGLUpdateInfo::dirtyViewportRect() {
     qFatal("Not implemented yet!");
-    return viewportRect.toAlignedRect();
+    return QRect();
 }
 
 #endif /* HAVE_OPENGL */
